Page MenuHomePhabricator

Set the edit summary when editing the representation and/or grammatical features of the form
Closed, ResolvedPublic

Description

Represetations

Before: EN color
After: EN colour

Summary: Changed English representation of Form 1: colour

Before: EN-GB colour, EN-US color
After: EN-GB-colour

Summary: Removed American English representation of Form 1: color
Fall back to [en-gb] if we can't get the language name the same way we do it for terms.

Before: EN-GB colour
After: EN-GB colour, EN-US color

Summary: Added American English representation of Form 1: color
Fall back to [en-gb] if we can't get the language name the same way we do it for terms.

Grammatical features

Before: Q666 (dative)
After: Q777 (accusative)

Summary: Changed grammatical feature of Form 1: accusative (Q777)

Before: Q666 (dative), Q888 (singular)
After: Q666 (dative)

Summary: Removed grammatical feature of Form 1: singular (Q888)

Before: Q666 (dative)
After: Q666 (dative), Q888 (singular)

Summary: Added grammatical feature of Form 1: singular (Q888)

Bonus question: It's been decided once that when the user changes both representation(s) and grammatical feature(s), and then clicks save, the changes she made are stored as a single edit, thus there is a single edit summary to consider. Question then: How would the summary look in such a case?
Hint: one couldn't refer to item/property changes AFAIK, as when e.g. changing the label, and the description, and then saving, there are two edits saved on the item/property, and each has an edit summary about the respective field.
Answer: Combine them and just add one after the other.

Related Objects

Event Timeline

Assigning to @Lydia_Pintscher for now to fill in the parts missing the specs.

Lydia_Pintscher removed Lydia_Pintscher as the assignee of this task.Jan 14 2018, 12:41 PM
Lydia_Pintscher updated the task description. (Show Details)

I've added the proposals for the edit summaries. Let me know if I missed anything or if any of them are not possible.

As for the bonus question: Can we combine them and just add one after the other?

We've been thinking about combining, but then @Jonas brought up the possibility to abuse the summary and "hide" some bad edits. Given comment https://phabricator.wikimedia.org/T173744#3889897, it seems we're fine with going this path then.
All clear, will start working on this task!

WMDE-leszek moved this task from Backlog to In Progress on the Wikidata-Sprint-2018-01-17 board.
This comment was removed by WMDE-leszek.

Change 405316 had a related patch set uploaded (by WMDE-leszek; owner: WMDE-leszek):
[mediawiki/extensions/WikibaseLexeme@master] Set summary when editing form elements with the UI-dedicated API.

https://gerrit.wikimedia.org/r/405316

WMDE-leszek removed WMDE-leszek as the assignee of this task.Jan 19 2018, 4:52 PM
WMDE-leszek moved this task from In Progress to Review on the Wikidata-Sprint-2018-01-17 board.
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form to Set the edit summary when editing the representation and/or grammatical features of the form (days: 2).Jan 23 2018, 4:53 PM
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form (days: 2) to Set the edit summary when editing the representation and/or grammatical features of the form (days: 3).Jan 24 2018, 3:47 PM
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form (days: 3) to Set the edit summary when editing the representation and/or grammatical features of the form (days: 4).Jan 26 2018, 8:27 AM
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form (days: 4) to Set the edit summary when editing the representation and/or grammatical features of the form (days: 5).Jan 26 2018, 11:39 AM
WMDE-leszek updated the task description. (Show Details)Jan 29 2018, 11:11 AM
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form (days: 5) to Set the edit summary when editing the representation and/or grammatical features of the form (days: 6).Jan 30 2018, 9:44 AM
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form (days: 6) to Set the edit summary when editing the representation and/or grammatical features of the form (days: 7).Jan 30 2018, 2:03 PM
WMDE-leszek moved this task from Backlog to Review on the Wikidata-Sprint-2018-01-31 board.
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form (days: 7) to Set the edit summary when editing the representation and/or grammatical features of the form (days: 8).Jan 31 2018, 11:23 AM
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form (days: 8) to Set the edit summary when editing the representation and/or grammatical features of the form (days: 9).Feb 1 2018, 11:13 AM
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form (days: 9) to Set the edit summary when editing the representation and/or grammatical features of the form (days: 10).Feb 2 2018, 11:21 AM

From the discussion I had with @Lydia_Pintscher on Wednesday:

  • In our discussion we confirmed this: The user is able to edit as many grammatical features and representations as he wants the same time. One click on the save button should trigger one API request, and result in one history entry with one summary line.
  • Concatenating multiple atomic localizable summaries is a new concept for Wikibase and wikidata.org. (Even if is not a new concept for MediaWiki core.)
  • In the discussion we concluded we don't want to introduce this new concept (with all the consequences that follow, including UX considerations) right now. Possibly later, but not for this story.
  • Summary lines should be precise. Ideally the line should allow to understand what an edit is about without looking at the diff.
  • But this does not mean that all summary lines must always repeat all details from the edits they describe, no matter how complex the edit is. That's still the job of the diff.
  • Lydia estimated that use cases where only one element is touched (e.g. only one grammatical feature, or only one representation) are the majority. That's what Lydia cares about. If the majority of edits does have precise summaries, Lydia is happy. The remaining use cases that produce generic summary lines can be improved later, if needed.

The summary lines needed right now are:

  • Adding one or more grammatical features: "Added {{PLURAL:grammatical feature|grammatical features}} of L1-F1: …, …"
  • Removing one or more grammatical features: "Removed {{PLURAL:grammatical feature|grammatical features}} of L1-F1: …, …"
  • Adding one or more representations: "Added {{PLURAL:representation|representations}} of L1-F1: en: …, de: …"
  • Removing one or more representations: "Removed {{PLURAL:representation|representations}} of L1-F1: en: …, de: …"
  • Editing one or more representations: "Edited {{PLURAL:representation|representations}} of L1-F1: en: …, de: …"
  • A generic summary for all other types of edits.

Two additional summaries can be considered (@Lydia_Pintscher, please decide):

  • When grammatical features are added and remove the same time, a generic summary can say "Changed {{PLURAL:grammatical feature|grammatical features}} of L1-F1: …, …". The list does not show what's removed or added, but all elements that are there after the edit.
  • When representations are added, remove, and/or changed the same time, a generic summary can say "Changed {{PLURAL:representation|representations}} of L1-F1: en: …, de: …". The list does not show what's removed or added, but all elements that are there after the edit. Note: This is a new suggestion currently not listed in the tasks description. The difference between "Edited representations" and "Changed representations" is that "Edited" only lists elements that are actually touched in an edit, while "Changed" must list all.
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form (days: 10) to Set the edit summary when editing the representation and/or grammatical features of the form.Feb 5 2018, 10:48 AM
WMDE-leszek claimed this task.
WMDE-leszek moved this task from Review to In Progress on the Wikidata-Sprint-2018-01-31 board.
WMDE-leszek removed a project: Patch-For-Review.
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form to Set the edit summary when editing the representation and/or grammatical features of the form (days: 1).Feb 5 2018, 11:50 AM
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form (days: 1) to Set the edit summary when editing the representation and/or grammatical features of the form.Feb 6 2018, 9:00 AM
WMDE-leszek moved this task from In Progress to Review on the Wikidata-Sprint-2018-01-31 board.
He7d3r added a subscriber: He7d3r.Feb 6 2018, 3:27 PM
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form to Set the edit summary when editing the representation and/or grammatical features of the form (days: 1).Feb 7 2018, 8:30 AM
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form (days: 1) to Set the edit summary when editing the representation and/or grammatical features of the form (days: 2).Feb 8 2018, 8:28 AM
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form (days: 2) to Set the edit summary when editing the representation and/or grammatical features of the form (days: 3).Feb 8 2018, 11:42 AM

Change 409380 had a related patch set uploaded (by Thiemo Kreuz (WMDE); owner: Thiemo Kreuz (WMDE)):
[mediawiki/extensions/WikibaseLexeme@master] Fixups to Form edit summary classes and related

https://gerrit.wikimedia.org/r/409380

WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form (days: 3) to Set the edit summary when editing the representation and/or grammatical features of the form (days: 4).Feb 12 2018, 9:26 AM
WMDE-leszek renamed this task from Set the edit summary when editing the representation and/or grammatical features of the form (days: 4) to Set the edit summary when editing the representation and/or grammatical features of the form.Feb 12 2018, 10:55 AM
WMDE-leszek moved this task from Review to Done on the Wikidata-Sprint-2018-01-31 board.

Change 405316 merged by jenkins-bot:
[mediawiki/extensions/WikibaseLexeme@master] Set summary when editing form elements with the UI-dedicated API.

https://gerrit.wikimedia.org/r/405316

Change 409380 merged by jenkins-bot:
[mediawiki/extensions/WikibaseLexeme@master] Fixups to Form edit summary classes and related

https://gerrit.wikimedia.org/r/409380

WMDE-leszek removed WMDE-leszek as the assignee of this task.Feb 12 2018, 11:09 AM
WMDE-leszek removed a project: Patch-For-Review.
Lydia_Pintscher closed this task as Resolved.Feb 13 2018, 1:20 PM